#include<legopowerfunctions.h>

int lastTurn = 0; //last turn left; 1 is right
long duration; //Time from Sonar sensor - rebound - return to to Sonar sensor
long distance; // duration converted to distance in inches
const int trigPin = 2; //sending sonar sensor connection
const int echoPin = 3; // receiving sonar sensor connection
const int buzzerPin = 9;
LEGOPowerFunctions lego(11); //transmitter connection

void setup() {   
  Serial.begin (9600); 
  pinMode(trigPin, OUTPUT);   
  pinMode(buzzerPin, OUTPUT);
  pinMode(echoPin, INPUT); 
}   
 
void loop() {
  lego.SingleOutput(0, PWM_FWD5, BLUE, CH1); //Driving forward
  
  digitalWrite(trigPin, LOW);  //Sonar Set up
  delayMicroseconds(5); //Sonar Set up
  digitalWrite(trigPin, HIGH); //Sonar Set up
  delayMicroseconds(10); //Sonar Set up
  digitalWrite(trigPin, LOW); //Sonar Set up
  duration = pulseIn(echoPin, HIGH); //duration of send/receive sonar
  distance = (duration/2) * 0.0135;   //divide duration by two since time to send and retrieve
  Serial.print(duration); //for testing
  Serial.println();   // for testing
  Serial.print(distance); //for testing
  Serial.print(" in "); // for testing
  Serial.println();   // for testing
  
  if(distance < 12) {  
    Serial.print("<12"); //for testing
    Serial.println();   // for testing
    lego.SingleOutput(0, PWM_BRK, BLUE, CH1); //Stop
    delay(1000); //testing
    lego.SingleOutput(0, PWM_REV4, BLUE, CH1); //Backup
    tone(buzzerPin, 262, 1000);
    delay(1000); //Backup for 1 second
    } 

  if(distance >= 12 & distance < 18) {
    Serial.print("12-18"); //for testing
    Serial.println();   // for testing
    lego.SingleOutput(0, PWM_FLT, BLUE, CH1); //Slow Down to stop
    delay(1000); //testing
  }

  if (distance < 18) {
    Serial.print("<18"); //for testing
    Serial.println();   // for testing
    if(lastTurn==0) {
      Serial.print("Turn 0"); //for testing
      Serial.println();   // for testing
      lego.SingleOutput(0, PWM_FWD7, RED, CH1); //Turn Right
      delay(15); //Servo response time
      lego.SingleOutput(0, PWM_FWD2, BLUE, CH1); // Slow Forward
      delay(2000); //Turn for 2 second
      lego.SingleOutput(0, PWM_FLT, RED, CH1); //Return to center
      lastTurn = 1; 
      } 
      
    else {  
      Serial.print("Turn 1"); //for testing
      Serial.println();   // for testing
      lego.SingleOutput(0, PWM_REV7, RED, CH1);  //Turn Left
      delay(15); //Servo response time
      lego.SingleOutput(0, PWM_FWD2, BLUE, CH1); // Slow Forward
      delay(2000); //Turn for 2 second
      lego.SingleOutput(0, PWM_FLT, RED, CH1); //Return to center
      lastTurn = 0; 
      }
  }

}
